<?php

/*
        ----
        oDns  -  A php4/perl/mysql frontend for the BIND name server 
        ----

        * Copyright (C) 2000  Olivier Mueller <om@omnis.ch>

        $Id: odns_htmlstuff.php,v 1.2 2000/08/17 17:39:13 swix Exp $
        $Source: /cvsroot/oDns/odns/odns_htmlstuff.php,v $

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.
  
        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



function html_head($title) {

	print "<HTML><HEAD><TITLE>$title</TITLE>";
	?>
<style type="text/css">
//<!--
body {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt}
th   {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt; font-weight: bold; background-color: #D3DCE3;}
td   {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt;}
form   {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt}
h1   {  font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 16pt; font-weight: bold}
A:link    {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt; text-decoration: none; color: blue}
A:visited {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt; text-decoration: none; color: blue}
A:hover   {  font-family: Arial, Helvetica, sans-serif; font-size: 10pt; text-decoration: underline; color: red}
A:link.nav {  font-family: Verdana, Arial, Helvetica, sans-serif; color: #000000}
A:visited.nav {  font-family: Verdana, Arial, Helvetica, sans-serif; color: #000000}
A:hover.nav {  font-family: Verdana, Arial, Helvetica, sans-serif; color: red;}
.nav {  font-family: Verdana, Arial, Helvetica, sans-serif; color: #000000}
//-->
</style>
	<?php
	print "</HEAD><BODY BGCOLOR=#FFFFFF TEXT=#000000 LINK=#000080 VLINK=#000080 ALINK=#000080>";
}



function html_end() {

	print "</BODY></HTML>\n\n";	

}



function info_box($msg, $url, $button_label = "Back") {

	include('config.php');

	print "<form action=\"$url\" method=\"POST\">";
	print "<table bgcolor=\"lightblue\" width=\"250\">";
	print "<tr><td width=\"100%\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
	print "<b>$msg</b></font></td></tr>";
	print "<tr><td align=\"center\"><input type=\"submit\" value=\"$button_label\"></td></td></table>";
	print "</form>";
}


function msg_box($title, $msg) {

	include('config.php');

	print "<table bgcolor=\"lightblue\" width=\"250\">";
	print "<tr><td width=\"100%\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
	print "<b>$title</b></font></td></tr>";
	print "<tr><td align=\"center\">" . $msg . "</td></td></table>";
	print "</form>";
}


function auth_again_box($msg, $button_label, $url) {

	global $PHP_AUTH_USER;

	include('config.php');

	print "<form action=\"$url\" method=\"POST\">";
	print "<table bgcolor=\"lightblue\" width=\"250\">";
	print "<tr><td width=\"100%\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
	print "<b>$msg</b></font></td></tr>";
	print "<INPUT TYPE=HIDDEN  NAME=\"SeenBefore\"  VALUE=\"1\">";
	print "<INPUT TYPE=HIDDEN  NAME=\"OldAuth\"  VALUE=\"$PHP_AUTH_USER\">";
	print "<INPUT TYPE=HIDDEN  NAME=\"action\"  VALUE=\"login\">";
	print "<tr><td align=\"center\"><input type=\"submit\" value=\"$button_label\"></td></td></table>";
	print "<form>";
}


function html_login_form() {

		include('config.php');

                print "<table bgcolor=\"lightblue\" border=\"0\" cellpadding=\"3\">";

                print "<tr><td width=\"100%\" colspan=\"3\" bgcolor=\"#000000\"><font size=\"3\" color=\"#FFFFFF\">";
                print "<b>User Authentication</b></font></td></tr>";

                print "<tr><td>Please choose:</td>";

                print "<form action=\"$url_userlogin\" method=\"POST\">";
                print "<td align=\"center\"><input type=\"submit\"  value=\"Login\"></td>";
                print "<input type=\"hidden\" name=\"action\" value=\"login\">";
                print "</form>";

                print "<form action=\"$url_userlogin\" method=\"POST\">";
                print "<td align=\"center\"><input type=\"submit\" value=\"New user\"></td>";
                print "<input type=\"hidden\" name=\"action\" value=\"new\">";
                print "</form>";

                print "</tr>";   
                print "</table>";
}


function html_select_box($array, $name, $selected, $mode) {

        // mode: 0 = use both side of array : $key -> content /$value -> display
        // mode. 2 = use only the keys.

        print "<font size=\"-1\"><select name=\"$name\">";
        print "<option value=\"\"> - </option>";

        // check if $selected value is in array 
        // if not -> show default entry

        $found = 0;
        reset($array);
        while(list ($int3,$tmp3) = each ($array) ) {
                        if($int3 == $selected) { $found = 1; }
        }

        if (!$found) { $selected = $array["DEFAULT_VALUE"]; }


        // print select array

        reset($array);
        while(list ($int3,$tmp3) = each ($array) ) {

                if ($int3 == $array["DEFAULT_VALUE"]) {
                        $high_left = " * "; $high_right = " * ";
                } else {
                        $high_left = ""; $high_right = "";
                }

                if (!($int3 == "DEFAULT_VALUE")) {
        
                        if ($mode == 0) {
                                if ($int3 == "$selected") {
                        echo "<option value=\"$int3\" selected>" .$high_left . $tmp3 . $high_right . "</option>";
                                } else {
                        echo "<option value=\"$int3\">" .$high_left . $tmp3 .  $high_right . "</option>";
                                }
                        }

                        if ($mode == 2) {
                                if ($int3 == "$selected") {
                        echo "\n<option value=\"$int3\" selected>" .$high_left . $int3 . $high_right . "</option>";
                                } else {
                        echo "\n<option value=\"$int3\">" .$high_left . $int3 .  $high_right . "</option>";
                                }
                        }

                }
        }
        
        print "</select></font>";
}





?>
