<?php

/*
        ----
        oDns  -  A php4/perl/mysql frontend for the BIND name server 
        ----

        * Copyright (C) 2000  Olivier Mueller <om@omnis.ch>

        $Id: odns_sql_stuff.php,v 1.3 2000/08/17 22:14:25 swix Exp $
        $Source: /cvsroot/oDns/odns/odns_sql_stuff.php,v $

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.
  
        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



//
//
//

function db_connect() {
	global $conn,$db_database,$db_server,$db_login,$db_passwd;
	$conn = mysql_connect($db_server,$db_login,$db_passwd) || die ("Unable to connect to database!");
	mysql_select_db($db_database) || die ("Unable to access the database");
}

//
//
//

function db_disconnect() {
	global $conn;
	mysql_close($conn);
}

//
//
//

function load_data_array($table, $key, $value, $WHERE) { 


	global $conn;
	
   	$sql_query="SELECT $key,$value FROM $table $WHERE";
	
	$sql_result=mysql_query($sql_query);
	
   	if (mysql_num_rows($sql_result)) {
			
		while ($data = mysql_fetch_row($sql_result)) {

			$output[$data[0]] = $data[1];

		}
			
		return $output;

	} else {
		$output[""] = "";
      		return $output;
	}
}

//
//
//

function load_data_single($table, $key, $value, $WHERE) { 
	
	// TODO : remove "$value" -> it is _not_ used here. 
	global $conn;

	$sql_query="SELECT $key FROM $table $WHERE";

	$sql_result=mysql_query($sql_query);
	
        if (mysql_num_rows($sql_result)) {

		$output = mysql_fetch_row($sql_result);
		return $output[0];

		// is there a way to do "return (mysql_fetch_row($sql_result))[0];" like in perl ?

	} else {
		
	      return "";
	}
}


//
//
//


function dns_host_resolve($host_id) {

	global $conn, $tb_dns_hosts;

	$host = load_data_single($tb_dns_hosts, "host", "", "WHERE host_id LIKE '$host_id'");

	if ($host) {
		
		return dns_host_resolve($host);

	} else {

		return $host_id; 

	}

}

//
// 
//


function delete_domain_entries($table, $domain) { 
	
	global $conn;
        
	if ($domain) {
	$sql_query="DELETE FROM $table WHERE domain LIKE '$domain'";
	$sql_result=mysql_query($sql_query);
	}	

}

//
// 
//


function delete_host_entry($host_id) { 
	
	global $conn;
	include('config.php');
        
	if ($host_id) {
	    $sql_query="DELETE FROM $tb_dns_hosts WHERE host_id LIKE '$host_id'";
	    $sql_result=mysql_query($sql_query);
	}	

}

//
// 
//


function delete_contact_entry($contact_name) { 
	
	global $conn;
	include('config.php');
        
	if ($contact_name) {
    	    $sql_query="DELETE FROM $tb_dns_contacts WHERE contact_name LIKE '$contact_name'";
	    $sql_result=mysql_query($sql_query);
	}	
}


//
// 
//

function insert_domain_entries($table, $domain, $var_name, $var_content, $host_id, $entry_type = "soa", $mx_pref = 10) { 
	
	global $conn;

	if ($domain && $var_name && ($var_content || $host_id)) {

	$sql_query="INSERT INTO $table (domain,var_name,host_id,var_content,creation_date,entry_type,mx_pref) VALUES " .
		"('$domain', '$var_name', '$host_id', '$var_content', NOW(),'$entry_type','$mx_pref')";

	$sql_result=mysql_query($sql_query);
	}	
}



//
// 
//

function update_domain_list($table, $domain, $type, $host_id, $owner_id) { 
	
	// host_id : only for seconday usefull
	
	global $conn;

	if (domain_exist($domain)) { 

		// if yes -> update
		
		$sql_query = "UPDATE $table SET timestamp=NOW(),domain='$domain',type='$type',host_id='$host_id'";
		if ($owner_id) { $sql_query .= ",owner_id='$owner_id'"; }
		$sql_query .= " WHERE domain LIKE '$domain'";
		$sql_result = mysql_query($sql_query);

	} else {

		// if not -> insert
	
		$sql_query="INSERT INTO $table (domain,type,creation_date,host_id,owner_id) VALUES " .
		"('$domain', '$type', NOW(), '$host_id', '$owner_id')";
		$sql_result=mysql_query($sql_query);
	}
}


//
// 
//


function delete_remote_domain($domain, $sec_server) { 	

	global $conn, $tb_dns_servers;

	// "resolve" name using dns_hosts

        $sec_server = dns_host_resolve($sec_server);

	// only try to delete if we have access information for this secondary
	// name server.

	if (load_data_single($tb_dns_servers, "ip", "", "WHERE ip LIKE '$sec_server'")) {

		print "<br><B>Deleting domain from remote name server : $domain - $sec_server</b> ...\n";

		$sec_login = load_data_single($tb_dns_servers, "login", "", "WHERE ip LIKE '$sec_server'");
		$sec_passwd = load_data_single($tb_dns_servers, "passwd", "", "WHERE ip LIKE '$sec_server'");
		$sec_dbname = load_data_single($tb_dns_servers, "dbname", "", "WHERE ip LIKE '$sec_server'");
		$sec_tbname = load_data_single($tb_dns_servers, "tbname", "", "WHERE ip LIKE '$sec_server'");

        	if ($sec_conn = mysql_connect($sec_server,$sec_login,$sec_passwd)) {
        	
			if (mysql_select_db($sec_dbname)) {

			        $sql_query="DELETE FROM $sec_tbname WHERE domain LIKE '$domain' AND type LIKE 'slave'";
				// print "$sql_query<br>";
        			$sql_result=mysql_query($sql_query,$sec_conn);
	
				print "Ok<br>\n";

			} else {

				print "Warning: Unable to access db $sec_dbname on secondary server<br>\n";
			}

	       		mysql_close($sec_conn);

		} else { 
			
			print "Warning: Unable to update secondary server!<br>\n";
		}
	}
}

//
//
//




//
// 
//

function add_remote_domain($domain, $pri_server, $sec_server) { 	

	global $conn, $tb_dns_servers;

	// "resolve" name using dns_hosts

        $pri_server = dns_host_resolve($pri_server);
        $sec_server = dns_host_resolve($sec_server);

	print "PRI: $pri_server - SEC: $sec_server<br>";

	// only try to add if we have access information for this secondary
	// name server.

	if(load_data_single($tb_dns_servers, "ip", "", "WHERE ip LIKE '$sec_server'")) {

		print "<br><B>Adding domain on remote name server : $domain - $sec_server</b> ...\n";

		$sec_login = load_data_single($tb_dns_servers, "login", "", "WHERE ip LIKE '$sec_server'");
		$sec_passwd = load_data_single($tb_dns_servers, "passwd", "", "WHERE ip LIKE '$sec_server'");
		$sec_dbname = load_data_single($tb_dns_servers, "dbname", "", "WHERE ip LIKE '$sec_server'");
		$sec_tbname = load_data_single($tb_dns_servers, "tbname", "", "WHERE ip LIKE '$sec_server'");

        	if ($sec_conn = mysql_connect($sec_server,$sec_login,$sec_passwd)) {
				
			print "mysql_connect($sec_server,$sec_login,$sec_passwd)<br>";
        	
			if (mysql_select_db($sec_dbname)) {

				// todo : now it will be "inserted" at every change : should first check if
				// it exists, and insert it only if the answer is no... anyway, it does work ok.

                		$sql_query="INSERT INTO $sec_tbname (domain,type,creation_date,host_id,owner_id) VALUES " .
                		"('$domain', 'slave', NOW(), '$pri_server', '$server_id')";
				
				print $sql_query . "<br>";
        			$sql_result=mysql_query($sql_query,$sec_conn);

				print "Ok<br>\n";

			} else {

				print "Warning: Unable to access db $sec_dbname on secondary server<br>\n";
			}

	       		mysql_close($sec_conn);

		} else { 
			
			print "Warning: Unable to connect the secondary server!<br>\n";

		}
	} else {
	
	    print "Warning: no access informations about the secondary: NOT updating it.<br>\n";
	}
}
        




//
//
//

function domain_exist($domain) {
	
	// check if domain exist in dns database 
	// returns 1 if it exists, 0 otherwise

	global $conn, $tb_dns_domains;

	$sql_query = "SELECT * FROM $tb_dns_domains WHERE domain LIKE '$domain'";
	$sql_result = mysql_query($sql_query);

	if (mysql_num_rows($sql_result)) { 
		return 1;
	} else {
		return 0;
	}

}

//
//
//

function domain_entry_exist($domain, $entry) {
	
	// check if a specific entry exist for a domain 
	// returns 1 if it exists, 0 otherwise

	global $conn, $tb_dns_entries;

	$sql_query = "SELECT * FROM $tb_dns_entries WHERE domain LIKE '$domain' AND var_name LIKE '$entry'";
	$sql_result = mysql_query($sql_query);

	if (mysql_num_rows($sql_result)) { 
		return 1;
	} else {
		return 0;
	}

}

//
//
//

function add_new_domain($domain, $source, $owner_id) {


	global $conn, $tb_dns_entries, $tb_dns_domains;

	if (domain_exist($domain)) { 

		return 0;

	} else {

		// upd dom list with new owner id
		
		update_domain_list($tb_dns_domains, $domain, "primary", "", $owner_id);		

		// read data from source domain (from dns_entries)
	
		$A_entries_host = load_data_array($tb_dns_entries, "var_name", "host_id", "WHERE host_id NOT LIKE '' AND domain LIKE '$source'");
		$A_entries_var = load_data_array($tb_dns_entries, "var_name", "var_content", "WHERE var_content NOT LIKE '' AND domain LIKE '$source'");

		// save data for new domain
		// special things:
		// 1. if entryname = source -> entryname = domain
		// 2. setup actual soa serial
	
		// variables
	    	while(list ($int,$tmp) = each ($A_entries_var) ) {

			if ($int == "soa_serial") { $tmp = date("Ymd00"); }
			if ($int == $source) { $int = $domain; }

			insert_domain_entries($tb_dns_entries, $domain, $int, $tmp, "");
		}

		// hosts
	    	while(list ($int,$tmp) = each ($A_entries_host) ) {

			if ($int == $source) { $int = $domain; }

			insert_domain_entries($tb_dns_entries, $domain, $int, "", $tmp);
		}

		return 1;

	}
	
	


}

//
//
//

function add_host($domain, $entry) {

	global $conn, $tb_dns_entries, $PHP_SELF;

	if (domain_entry_exist($domain,$entry)) {

		return 0;

	} else {
        
		// read contents of the www entry

		$host_id = load_data_single($tb_dns_entries, "host_id", "", "WHERE domain LIKE '$domain' AND var_name LIKE 'www'");
		$var_content = load_data_single($tb_dns_entries, "var_content", "", "WHERE domain LIKE '$domain' AND var_name LIKE 'www'");
		
		// insert new entry
		
		if ($host_id || $var_content) {

			insert_domain_entries($tb_dns_entries, $domain, $entry, $var_content, $host_id);
			return 1;

		} else {
		
			return 0;
		}
		

	}
}

//
//
//

function check_ownership($type, $data) {

	global $conn, $owner_id, $PHP_SELF;
	include('config.php');
    
	$result = -1;
	
	if ($type == "domain") {
		$sql_query = "SELECT owner_id FROM $tb_dns_domains WHERE domain LIKE '$data'";
	}
	if ($type == "host") {
		$sql_query = "SELECT owner_id FROM $tb_dns_hosts WHERE host_id LIKE '$data'";
	}	
	if ($type == "contact") {
		$sql_query = "SELECT owner_id FROM $tb_dns_contacts WHERE contact_name LIKE '$data'";
	}
	
	
	if ($sql_query) {
	    $sql_result = mysql_query($sql_query);
	    if (mysql_num_rows($sql_result)) {
		$tmp_array = mysql_fetch_row($sql_result);
		$result = $tmp_array[0];
	    } else {
		$result = -1;
	    }
	} else { 
	    $result = -1; print "noquery";
	}
	
	if ($result == $owner_id || ($owner_id == 0 && $result != -1)) {

	    return;

        } elseif ($result == -1) {
	    html_head("oDns - Error");
	    info_box("Error: no such $type", $PHP_SELF);
	    html_end();
	    exit();
	} else {
	    html_head("oDns - Error");
    	    info_box("Error: not your $type", $PHP_SELF);
	    html_end();
	    exit();
	}

}


//
//
//

function check_if_exists($type, $data) {

	global $conn, $owner_id, $PHP_SELF;
	include('config.php');
    
	$result = -1;
	
	if ($type == "domain") {
		$sql_query = "SELECT owner_id FROM $tb_dns_domains WHERE domain LIKE '$data'";
	}
	if ($type == "host") {
		$sql_query = "SELECT owner_id FROM $tb_dns_hosts WHERE host_id LIKE '$data'";
	}	
	if ($type == "contact") {
		$sql_query = "SELECT owner_id FROM $tb_dns_contacts WHERE contact_name LIKE '$data'";
	}
	
	
	if ($sql_query) {
	    $sql_result = mysql_query($sql_query);
	    if (mysql_num_rows($sql_result)) {
		$tmp_array = mysql_fetch_row($sql_result);
		$result = $tmp_array[0];
	    } else {
		$result = -1;
	    }
	} else { 
	    $result = -1; print "noquery";
	}
	
	if ($result == -1) {

	    return;

        } else {
	    html_head("oDns - Error");
    	    info_box("Error: sorry, this $type already exists. Please edit or delete it if you want to recreate it!", $PHP_SELF);
	    html_end();
	    exit();
	}

}


//
//
//

function check_if_in_use($type, $data) {

	global $conn, $owner_id, $PHP_SELF;
	include('config.php');
    
	$result = -1;
	
	if ($type == "contact") {
		$sql_query = "SELECT * FROM $tb_dns_entries WHERE var_name LIKE 'soa_nic_%' AND var_content LIKE '$data'";
	}	
	if ($type == "host") {
	 	$sql_query  = "SELECT * FROM $tb_dns_entries WHERE host_id LIKE '$data'";
		$sql_query2 = "SELECT * FROM $tb_dns_domains WHERE type NOT LIKE 'primary' AND host_id LIKE '$data'";
	}
	
	
	if ($sql_query) {
	    $sql_result = mysql_query($sql_query);
	    if ($sql_query2) { 
		$sql_result2 = mysql_query($sql_query2); 
	        if (mysql_num_rows($sql_result2)) { $stop2 = 1; }	
	    } else { $stop2 = 0; }
	    

	    if (mysql_num_rows($sql_result) || $stop2) {
		    html_head("oDns - Error");
    		    info_box("Error: sorry, this $type is still used on one or more zone files!", $PHP_SELF);
		    html_end();
		    exit();
	    } 
	}

}




?>
